FOLDER=/usr/share/ilabs_antimalware
OK=1
CMD="-i"

if [ ! -z "$@" ]; then
        CMD="$@"
fi

function upgrade_script(){
	echo "Upgrading script..."
	# COmprobar que estamos en la carpeta correcta
	if [ ! -e modsec_scan.php ]; then
		echo "Wrong folder. Aborting Upgrade."
		exit 1
	fi

	if [ ! -d $FOLDER ]; then
		mkdir $FOLDER
	fi

	# Copiar todos los archivos a la carpeta de destino
	# No copiar el archivo license.txt
	rm -f license.txt 
	cp * $FOLDER -fR

	# Mover el acceso en WHM
	# mv -f $FOLDER/addon_antimalware.php  /usr/local/cpanel/whostmgr/docroot/cgi/
	# chmod 0755 /usr/local/cpanel/whostmgr/docroot/cgi/addon_antimalware.php

	# Registrar la aplicacion en WHM si no ha sido registrada
	/usr/local/cpanel/bin/register_appconfig /usr/share/ilabs_antimalware/includes/pyxsoft_antimalware.conf
	if [ ! -f "/var/cpanel/apps/pyxsoft_antimalware.conf" ]; then
		if [ -f "/usr/local/cpanel/bin/register_appconfig" ]; then
		/usr/local/cpanel/bin/register_appconfig /usr/share/ilabs_antimalware/includes/pyxsoft_antimalware.conf
		fi
	fi
		
	# Establecer permisos para archivos que utilizara mod security
	chmod 0755 $FOLDER/modsec_name_scan.php
	chmod 0755 $FOLDER/modsec_scan.php
	chmod 0755 $FOLDER/firewall/checkdenied.sh
	touch $FOLDER/filescan.log
	chmod 0666 $FOLDER/filescan.log
	chmod 0666 $FOLDER/license.txt
	touch $FOLDER/firewall/ipdeny.txt
	chmod 0666 $FOLDER/firewall/ipdeny.txt
	touch $FOLDER/logs/firewall.log
	chmod 0666 $FOLDER/logs/firewall.log
	touch $FOLDER/firewall/f.dat
	chmod 0666 $FOLDER/firewall/f.dat
        touch $FOLDER/data/enc_pas.dat
        chmod 0666 $FOLDER/data/enc_pas.dat
	
	# -> Escritura de version de modsecurity
	chmod 0755 $FOLDER/getmodsecversion.php
	touch $FOLDER/logs/modsecversion.txt
	chmod 0666 $FOLDER/logs/modsecversion.txt

	# -> Chequeo de editor de texto de aplicaciones
	chmod 0755 $FOLDER/adicionales/checkApp.php
	touch $FOLDER/logs/checkApp.log
	chmod 0666 $FOLDER/logs/checkApp.log

	# -> Verificar estado de proteccion http
	chmod 0755 $FOLDER/adicionales/ok.php
	touch $FOLDER/logs/ok.txt
	chmod 0666 $FOLDER/logs/ok.txt
	
	# -> Analizar ataques de fuerza bruta
	chmod 0755 $FOLDER/adicionales/pyx_bf.php
	touch $FOLDER/logs/loginfailed.log
	chmod 0666 $FOLDER/logs/loginfailed.log
	touch $FOLDER/data/bruteforce.dat
	chmod 0666 $FOLDER/data/bruteforce.dat
	touch $FOLDER/data/badips.dat
	chmod 0666 $FOLDER/data/badips.dat
	chmod 0755 $FOLDER/adicionales/bf_test.php
	
	# Actualizar archivo de aviso a usuarios
	mv $FOLDER/amplugin.shtml /usr/local/cpanel/cgi-sys/amplugin.shtml -f
	chmod 0644 /usr/local/cpanel/cgi-sys/amplugin.shtml
	chown root:wheel /usr/local/cpanel/cgi-sys/amplugin.shtml

	mv $FOLDER/denied.shtml /usr/local/cpanel/cgi-sys/denied.shtml -f
	chmod 0644 /usr/local/cpanel/cgi-sys/denied.shtml
	chown root:wheel /usr/local/cpanel/cgi-sys/denied.shtml

	# Agregar inspeccion en mod_security
	echo "Determining the Mod Security installed version..."
	echo -n "0" > /usr/share/ilabs_antimalware/logs/modsecversion.txt
	wget `hostname`?getMS_version -O /dev/null  -q
	version=$(</usr/share/ilabs_antimalware/logs/modsecversion.txt)

	if [ $version -eq 0 ]; then
		echo "Mod security version could not be detected."
		echo "It is normal, I will detect the version when you visit the plugin in WHM."
		\cp -f $FOLDER/modsec2.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf
	elif [ "$version" -ge "02060000" ]; then
		echo "Mod security version OK ($version)"
		\cp -f $FOLDER/modsec0260.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf

	else
		echo "You have a very old mod security version. Some pyxsoft features will not work here."
		\cp -f $FOLDER/modsec2.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf
	fi

	chmod 0644 /usr/local/apache/conf/modsec2.antimalware.conf 
	
	# Eliminar archivos innecesarios de la carpeta del usuario
	rm -f $FOLDER/install.sh
	
	# Descargar las firmas para usar por primera vez (se puede eliminar esta seccion m�s adelante)
	wget http://www.pyxsoft.com/software/antimalware/sigs/am.ndb -O /usr/share/ilabs_antimalware/sigs/am.ndb
	wget http://www.pyxsoft.com/software/antimalware/sigs/am1.ndb -O /usr/share/ilabs_antimalware/sigs/am1.ndb
	wget http://www.pyxsoft.com/software/antimalware/sigs/am1.hdb -O /usr/share/ilabs_antimalware/sigs/am1.hdb
	if [ -e $FOLDER/sigs/rfxn.hdb ]; then
		rm -f $FOLDER/sigs/rfxn.*
	fi
	
	# Instalar FTP inspector
	chmod 755 $FOLDER/pure-ftpd-inspector.php
	if grep 'pure-ftpd-inspector' /etc/init.d/pure-ftpd >/dev/null; then
        echo "FTP Inspector already installed"
	else
		echo "Installing FTP Inspector..."
		# La salida hacia dev null impide que PHP se quede pegado
		sh $FOLDER/includes/install_ftp_inspector.sh >/dev/null
	fi
	
	# Establecer permisos de ejecucion a comandos
	chmod 0755 $FOLDER/commands/* 
	chmod 0755 $FOLDER/pyxsoft-antimalware.pl

	# Actualizar servicio pyxsoft-antimalware
	\cp -f /usr/share/ilabs_antimalware/system_files/pyxsoft-antimalware /etc/init.d/pyxsoft-antimalware
	chmod 0755 /etc/init.d/pyxsoft-antimalware
	chown root:root /etc/init.d/pyxsoft-antimalware

	# Instalar cron
	echo "4 2 * * * root /usr/local/cpanel/3rdparty/bin/php $FOLDER/cron/daily.php" > /etc/cron.d/pyx_antimalware
	echo "*/10 * * * * root /usr/local/cpanel/3rdparty/bin/php $FOLDER/cron/cronjobs.php" > /etc/cron.d/pyx_cronjobs
	
	# Reparar la configuracion de modse2.conf y httpd.conf
	# que eventualmente puede estar bloqueando la ejecucion de reglas
	# desde 127.0.0.1
	/usr/local/cpanel/3rdparty/bin/php -q /usr/share/ilabs_antimalware/includes/modsec_fix.php
	
	# Reiniciar apache debido a las nuevas reglas en mod security
	echo "<code>"
	/etc/init.d/httpd restart 2>&1
	echo "</code>"
	
	echo 
	echo "*****************************"
	echo " Antimalware plugin upgraded"
	echo "*****************************"
	echo
	
	cat /usr/share/ilabs_antimalware/whatsnew.txt

}

# Reparar permisos
find -type d -exec chmod 755 '{}' \; ; find -type f -exec chmod 644 '{}' \; ;echo "Permissions Fix Done"

# Realizar upgrade si corresponde
if [ $CMD = '-u' ]; then
	upgrade_script
	exit 0
fi


# Determinar si clamav esta instalado
if [ ! -e /usr/bin/clamscan ] && [ ! -e /usr/local/cpanel/3rdparty/bin/clamscan ]; then
	echo "ClamAV is not installed. Install it using WHM plugins before installing Pyxsoft Anti Malware"
	exit 1
fi

# Determinar si mod security 2 esta instalado
if grep -E -i '^include.+?modsec2' /usr/local/apache/conf/httpd.conf >/dev/null; then
        echo "Mod Security 2 installed [OK]"
else
        echo "Mod Security 2 installed [ERROR]"
		echo "Please install mod security before installing Pyxsoft Anti Malware"
        exit 1
fi

# Determinar si Ioncube está habilitado en cPanel
ioncube=`/usr/local/cpanel/3rdparty/bin/php -v | grep -i 'ioncube'`
if  [ "$ioncube" != "" ]; then
        echo "Internal Ioncube enabled [OK]"
else
        echo "Internal Ioncube enabled [ERROR]"
		echo "Please enable internal cPanel ioncube loader before installing Pyxsoft Anti Malware"
        exit 1
fi

# Determinar si est� corriendo pure-ftpd
if [ ! -e /var/run/pure-ftpd.pid ]; then
	echo  "Pure FTP is not running in your system."
	echo  "Pure FTP is required."
	exit 1
fi


############################################################################
# Instalar antimalware
############################################################################

# Comprobar que estamos en la carpeta correcta
if [ ! -e modsec_scan.php ]; then
	echo "Wrong folder. Aborting Install."
	exit 1
fi

if [ ! -d $FOLDER ]; then
	mkdir $FOLDER
fi

# Activar programa
H="http://www.pyxsoft.com/gl.php?h=$(hostname)"; wget -q -O - $H > /dev/null

# Copiar todos los archivos a la carpeta de destino
cp * $FOLDER -fR

# Crear la carpeta reports
mkdir $FOLDER/reports

# Descargar las firmas para usar por primera vez
wget http://www.pyxsoft.com/software/antimalware/sigs/am.ndb -O /usr/share/ilabs_antimalware/sigs/am.ndb
wget http://www.pyxsoft.com/software/antimalware/sigs/am1.ndb -O /usr/share/ilabs_antimalware/sigs/am1.ndb
wget http://www.pyxsoft.com/software/antimalware/sigs/am1.hdb -O /usr/share/ilabs_antimalware/sigs/am1.hdb

# Crear el acceso en WHM
cp addon_antimalware.php  /usr/local/cpanel/whostmgr/docroot/cgi/ -f
chmod 0755 /usr/local/cpanel/whostmgr/docroot/cgi/addon_antimalware.php
ln -s /usr/share/ilabs_antimalware /usr/local/cpanel/whostmgr/docroot/cgi/ilabs_antimalware
rm $FOLDER/addon_antimalware.php -f

# Registrar la aplicacion en WHM si no ha sido registrada
/usr/local/cpanel/bin/register_appconfig /usr/share/ilabs_antimalware/includes/pyxsoft_antimalware.conf
if [ ! -f "/var/cpanel/apps/pyxsoft_antimalware.conf" ]; then
	if [ -f "/usr/local/cpanel/bin/register_appconfig" ]; then
		/usr/local/cpanel/bin/register_appconfig /usr/share/ilabs_antimalware/includes/pyxsoft_antimalware.conf
	fi
fi
	

# Establecer permisos para archivos que utilizara mod security
chmod 0755 $FOLDER/modsec_name_scan.php
chmod 0755 $FOLDER/modsec_scan.php
chmod 0755 $FOLDER/firewall/checkdenied.sh
touch $FOLDER/filescan.log
touch $FOLDER/ftp.log
touch $FOLDER/firewall/ipdeny.txt
chmod 0666 $FOLDER/filescan.log
chmod 0666 $FOLDER/license.txt
chmod 0666 $FOLDER/firewall/ipdeny.txt
touch $FOLDER/logs/firewall.log
chmod 0666 $FOLDER/logs/firewall.log
touch $FOLDER/firewall/f.dat
chmod 0666 $FOLDER/firewall/f.dat
touch $FOLDER/data/enc_pas.dat
chmod 0666 $FOLDER/data/enc_pas.dat

# -> Escritura de version de modsecurity
chmod 0755 $FOLDER/getmodsecversion.php
touch $FOLDER/logs/modsecversion.txt
chmod 0666 $FOLDER/logs/modsecversion.txt

# -> Chequeo de editor de texto de aplicaciones
chmod 0755 $FOLDER/adicionales/checkApp.php
touch $FOLDER/logs/checkApp.log
chmod 0666 $FOLDER/logs/checkApp.log

# -> Verificar estado de proteccion http
chmod 0755 $FOLDER/adicionales/ok.php
touch $FOLDER/logs/ok.txt
chmod 0666 $FOLDER/logs/ok.txt

# -> Analizar ataques de fuerza bruta
chmod 0755 $FOLDER/adicionales/pyx_bf.php
touch $FOLDER/logs/loginfailed.log
chmod 0666 $FOLDER/logs/loginfailed.log
touch $FOLDER/data/bruteforce.dat
chmod 0666 $FOLDER/data/bruteforce.dat
touch $FOLDER/data/badips.dat
chmod 0666 $FOLDER/data/badips.dat
chmod 0755 $FOLDER/adicionales/bf_test.php

# Agregar archivo de aviso a usuarios
mv $FOLDER/amplugin.shtml /usr/local/cpanel/cgi-sys/amplugin.shtml -f
chmod 0644 /usr/local/cpanel/cgi-sys/amplugin.shtml
chown root:wheel /usr/local/cpanel/cgi-sys/amplugin.shtml

mv $FOLDER/denied.shtml /usr/local/cpanel/cgi-sys/denied.shtml -f
chmod 0644 /usr/local/cpanel/cgi-sys/denied.shtml
chown root:wheel /usr/local/cpanel/cgi-sys/denied.shtml

# Agregar inspeccion en mod_security
echo "Determining the Mod Security installed version..."
echo -n "0" > /usr/share/ilabs_antimalware/logs/modsecversion.txt
wget `hostname`?getMS_version -O /dev/null  -q
version=$(</usr/share/ilabs_antimalware/logs/modsecversion.txt)

if [ $version -eq 0 ]; then
	echo "Mod security version could not be detected this time."
	echo "It will be detected when you visit the plugin in WHM"
	\cp -f $FOLDER/modsec2.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf
elif [ "$version" -ge "02060000" ]; then
	echo "Mod security version OK ($version)"
	\cp -f $FOLDER/modsec0260.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf

else
	echo "You have a very old mod security version. Some pyxsoft features will not work here."
	\cp -f $FOLDER/modsec2.antimalware.conf /usr/local/apache/conf/modsec2.antimalware.conf 
fi

chmod 0644 /usr/local/apache/conf/modsec2.antimalware.conf 
rm -f $FOLDER/install.sh

# Instalar FTP inspector
chmod 755 $FOLDER/pure-ftpd-inspector.php
if grep 'pure-ftpd-inspector' /etc/init.d/pure-ftpd >/dev/null; then
	echo "FTP Inspector already installed"
else
	echo "Installing FTP Inspector..."	
	sh $FOLDER/includes/install_ftp_inspector.sh
fi

# Instalar servicio pyxsoft-antimalware
\cp -f /usr/share/ilabs_antimalware/system_files/pyxsoft-antimalware /etc/init.d/pyxsoft-antimalware
chmod 0755 /etc/init.d/pyxsoft-antimalware
chown root:root /etc/init.d/pyxsoft-antimalware


# Establecer permisos de ejecucion a comandos
chmod 0755 $FOLDER/commands/* 
chmod 0755 $FOLDER/pyxsoft-antimalware.pl

# Instalar cron
echo "4 2 * * * root /usr/local/cpanel/3rdparty/bin/php $FOLDER/cron/daily.php" > /etc/cron.d/pyx_antimalware
echo "*/10 * * * * root /usr/local/cpanel/3rdparty/bin/php $FOLDER/cron/cronjobs.php" > /etc/cron.d/pyx_cronjobs

# Reparar la configuracion de modse2.conf y httpd.conf
# que eventualmente puede estar bloqueando la ejecucion de reglas
# desde 127.0.0.1
/usr/local/cpanel/3rdparty/bin/php -q /usr/share/ilabs_antimalware/includes/modsec_fix.php
	
# Revisar si esta incluida la configuracion en el archivo modsec2.conf
if grep -E -i '^include.+?modsec2\.antimalware\.conf' /usr/local/apache/conf/modsec2.user.conf >/dev/null; then
        echo "Inspector already enabbled"
else
	echo "# Pyxsoft Antimalware" > newfile.txt
	echo 'Include /usr/local/apache/conf/modsec2.antimalware.conf' >>newfile.txt
	echo  >>newfile.txt
	cat /usr/local/apache/conf/modsec2.user.conf >> newfile.txt
	mv /usr/local/apache/conf/modsec2.user.conf /usr/local/apache/conf/modsec2.user.conf.bak -f
	mv newfile.txt /usr/local/apache/conf/modsec2.user.conf -f
	chmod 0600 /usr/local/apache/conf/modsec2.user.conf
	chmod 0600 /usr/local/apache/conf/modsec2.antimalware.conf
	echo "Inspector enabled OK"
	echo "Restarting apache..."
	/etc/init.d/httpd restart 2>&1
fi


echo ""
echo ""
echo "****************************************"
echo "* Antimalware Plugin installed"
echo "* Please review configuration in WHM"
echo "****************************************"



